package de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.services.MyDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDslParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "','", "'initial'", "'final'", "'State'", "'{'", "'}'", "'Transition'", "'/'", "'target'", "'WRITE'", "'ERASE'", "'NULL'", "'LEFT'", "'RIGHT'", "'NONE'"
    };
    public static final int RULE_STRING=4;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=6;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalMyDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMyDsl.g"; }



     	private MyDslGrammarAccess grammarAccess;

        public InternalMyDslParser(TokenStream input, MyDslGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "TuringMachine";
       	}

       	@Override
       	protected MyDslGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleTuringMachine"
    // InternalMyDsl.g:65:1: entryRuleTuringMachine returns [EObject current=null] : iv_ruleTuringMachine= ruleTuringMachine EOF ;
    public final EObject entryRuleTuringMachine() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTuringMachine = null;


        try {
            // InternalMyDsl.g:65:54: (iv_ruleTuringMachine= ruleTuringMachine EOF )
            // InternalMyDsl.g:66:2: iv_ruleTuringMachine= ruleTuringMachine EOF
            {
             newCompositeNode(grammarAccess.getTuringMachineRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTuringMachine=ruleTuringMachine();

            state._fsp--;

             current =iv_ruleTuringMachine; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTuringMachine"


    // $ANTLR start "ruleTuringMachine"
    // InternalMyDsl.g:72:1: ruleTuringMachine returns [EObject current=null] : ( ( (lv_states_0_0= ruleState ) ) (otherlv_1= ',' ( (lv_states_2_0= ruleState ) ) )* ) ;
    public final EObject ruleTuringMachine() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_states_0_0 = null;

        EObject lv_states_2_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:78:2: ( ( ( (lv_states_0_0= ruleState ) ) (otherlv_1= ',' ( (lv_states_2_0= ruleState ) ) )* ) )
            // InternalMyDsl.g:79:2: ( ( (lv_states_0_0= ruleState ) ) (otherlv_1= ',' ( (lv_states_2_0= ruleState ) ) )* )
            {
            // InternalMyDsl.g:79:2: ( ( (lv_states_0_0= ruleState ) ) (otherlv_1= ',' ( (lv_states_2_0= ruleState ) ) )* )
            // InternalMyDsl.g:80:3: ( (lv_states_0_0= ruleState ) ) (otherlv_1= ',' ( (lv_states_2_0= ruleState ) ) )*
            {
            // InternalMyDsl.g:80:3: ( (lv_states_0_0= ruleState ) )
            // InternalMyDsl.g:81:4: (lv_states_0_0= ruleState )
            {
            // InternalMyDsl.g:81:4: (lv_states_0_0= ruleState )
            // InternalMyDsl.g:82:5: lv_states_0_0= ruleState
            {

            					newCompositeNode(grammarAccess.getTuringMachineAccess().getStatesStateParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_3);
            lv_states_0_0=ruleState();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTuringMachineRule());
            					}
            					add(
            						current,
            						"states",
            						lv_states_0_0,
            						"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.State");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalMyDsl.g:99:3: (otherlv_1= ',' ( (lv_states_2_0= ruleState ) ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalMyDsl.g:100:4: otherlv_1= ',' ( (lv_states_2_0= ruleState ) )
            	    {
            	    otherlv_1=(Token)match(input,11,FOLLOW_4); 

            	    				newLeafNode(otherlv_1, grammarAccess.getTuringMachineAccess().getCommaKeyword_1_0());
            	    			
            	    // InternalMyDsl.g:104:4: ( (lv_states_2_0= ruleState ) )
            	    // InternalMyDsl.g:105:5: (lv_states_2_0= ruleState )
            	    {
            	    // InternalMyDsl.g:105:5: (lv_states_2_0= ruleState )
            	    // InternalMyDsl.g:106:6: lv_states_2_0= ruleState
            	    {

            	    						newCompositeNode(grammarAccess.getTuringMachineAccess().getStatesStateParserRuleCall_1_1_0());
            	    					
            	    pushFollow(FOLLOW_3);
            	    lv_states_2_0=ruleState();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getTuringMachineRule());
            	    						}
            	    						add(
            	    							current,
            	    							"states",
            	    							lv_states_2_0,
            	    							"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.State");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTuringMachine"


    // $ANTLR start "entryRuleState"
    // InternalMyDsl.g:128:1: entryRuleState returns [EObject current=null] : iv_ruleState= ruleState EOF ;
    public final EObject entryRuleState() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleState = null;


        try {
            // InternalMyDsl.g:128:46: (iv_ruleState= ruleState EOF )
            // InternalMyDsl.g:129:2: iv_ruleState= ruleState EOF
            {
             newCompositeNode(grammarAccess.getStateRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleState=ruleState();

            state._fsp--;

             current =iv_ruleState; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleState"


    // $ANTLR start "ruleState"
    // InternalMyDsl.g:135:1: ruleState returns [EObject current=null] : ( () ( (lv_initial_1_0= 'initial' ) )? ( (lv_final_2_0= 'final' ) )? otherlv_3= 'State' ( (lv_name_4_0= ruleEString ) ) (otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}' )? ) ;
    public final EObject ruleState() throws RecognitionException {
        EObject current = null;

        Token lv_initial_1_0=null;
        Token lv_final_2_0=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        AntlrDatatypeRuleToken lv_name_4_0 = null;

        EObject lv_outgoingTransitions_6_0 = null;

        EObject lv_outgoingTransitions_8_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:141:2: ( ( () ( (lv_initial_1_0= 'initial' ) )? ( (lv_final_2_0= 'final' ) )? otherlv_3= 'State' ( (lv_name_4_0= ruleEString ) ) (otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}' )? ) )
            // InternalMyDsl.g:142:2: ( () ( (lv_initial_1_0= 'initial' ) )? ( (lv_final_2_0= 'final' ) )? otherlv_3= 'State' ( (lv_name_4_0= ruleEString ) ) (otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}' )? )
            {
            // InternalMyDsl.g:142:2: ( () ( (lv_initial_1_0= 'initial' ) )? ( (lv_final_2_0= 'final' ) )? otherlv_3= 'State' ( (lv_name_4_0= ruleEString ) ) (otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}' )? )
            // InternalMyDsl.g:143:3: () ( (lv_initial_1_0= 'initial' ) )? ( (lv_final_2_0= 'final' ) )? otherlv_3= 'State' ( (lv_name_4_0= ruleEString ) ) (otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}' )?
            {
            // InternalMyDsl.g:143:3: ()
            // InternalMyDsl.g:144:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getStateAccess().getStateAction_0(),
            					current);
            			

            }

            // InternalMyDsl.g:150:3: ( (lv_initial_1_0= 'initial' ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==12) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalMyDsl.g:151:4: (lv_initial_1_0= 'initial' )
                    {
                    // InternalMyDsl.g:151:4: (lv_initial_1_0= 'initial' )
                    // InternalMyDsl.g:152:5: lv_initial_1_0= 'initial'
                    {
                    lv_initial_1_0=(Token)match(input,12,FOLLOW_5); 

                    					newLeafNode(lv_initial_1_0, grammarAccess.getStateAccess().getInitialInitialKeyword_1_0());
                    				

                    					if (current==null) {
                    						current = createModelElement(grammarAccess.getStateRule());
                    					}
                    					setWithLastConsumed(current, "initial", lv_initial_1_0 != null, "initial");
                    				

                    }


                    }
                    break;

            }

            // InternalMyDsl.g:164:3: ( (lv_final_2_0= 'final' ) )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==13) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalMyDsl.g:165:4: (lv_final_2_0= 'final' )
                    {
                    // InternalMyDsl.g:165:4: (lv_final_2_0= 'final' )
                    // InternalMyDsl.g:166:5: lv_final_2_0= 'final'
                    {
                    lv_final_2_0=(Token)match(input,13,FOLLOW_6); 

                    					newLeafNode(lv_final_2_0, grammarAccess.getStateAccess().getFinalFinalKeyword_2_0());
                    				

                    					if (current==null) {
                    						current = createModelElement(grammarAccess.getStateRule());
                    					}
                    					setWithLastConsumed(current, "final", lv_final_2_0 != null, "final");
                    				

                    }


                    }
                    break;

            }

            otherlv_3=(Token)match(input,14,FOLLOW_7); 

            			newLeafNode(otherlv_3, grammarAccess.getStateAccess().getStateKeyword_3());
            		
            // InternalMyDsl.g:182:3: ( (lv_name_4_0= ruleEString ) )
            // InternalMyDsl.g:183:4: (lv_name_4_0= ruleEString )
            {
            // InternalMyDsl.g:183:4: (lv_name_4_0= ruleEString )
            // InternalMyDsl.g:184:5: lv_name_4_0= ruleEString
            {

            					newCompositeNode(grammarAccess.getStateAccess().getNameEStringParserRuleCall_4_0());
            				
            pushFollow(FOLLOW_8);
            lv_name_4_0=ruleEString();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getStateRule());
            					}
            					set(
            						current,
            						"name",
            						lv_name_4_0,
            						"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.EString");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalMyDsl.g:201:3: (otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}' )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==15) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalMyDsl.g:202:4: otherlv_5= '{' ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )? otherlv_9= '}'
                    {
                    otherlv_5=(Token)match(input,15,FOLLOW_9); 

                    				newLeafNode(otherlv_5, grammarAccess.getStateAccess().getLeftCurlyBracketKeyword_5_0());
                    			
                    // InternalMyDsl.g:206:4: ( ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )* )?
                    int alt5=2;
                    int LA5_0 = input.LA(1);

                    if ( (LA5_0==17) ) {
                        alt5=1;
                    }
                    switch (alt5) {
                        case 1 :
                            // InternalMyDsl.g:207:5: ( (lv_outgoingTransitions_6_0= ruleTransition ) ) (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )*
                            {
                            // InternalMyDsl.g:207:5: ( (lv_outgoingTransitions_6_0= ruleTransition ) )
                            // InternalMyDsl.g:208:6: (lv_outgoingTransitions_6_0= ruleTransition )
                            {
                            // InternalMyDsl.g:208:6: (lv_outgoingTransitions_6_0= ruleTransition )
                            // InternalMyDsl.g:209:7: lv_outgoingTransitions_6_0= ruleTransition
                            {

                            							newCompositeNode(grammarAccess.getStateAccess().getOutgoingTransitionsTransitionParserRuleCall_5_1_0_0());
                            						
                            pushFollow(FOLLOW_10);
                            lv_outgoingTransitions_6_0=ruleTransition();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getStateRule());
                            							}
                            							add(
                            								current,
                            								"outgoingTransitions",
                            								lv_outgoingTransitions_6_0,
                            								"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.Transition");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }

                            // InternalMyDsl.g:226:5: (otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) ) )*
                            loop4:
                            do {
                                int alt4=2;
                                int LA4_0 = input.LA(1);

                                if ( (LA4_0==11) ) {
                                    alt4=1;
                                }


                                switch (alt4) {
                            	case 1 :
                            	    // InternalMyDsl.g:227:6: otherlv_7= ',' ( (lv_outgoingTransitions_8_0= ruleTransition ) )
                            	    {
                            	    otherlv_7=(Token)match(input,11,FOLLOW_11); 

                            	    						newLeafNode(otherlv_7, grammarAccess.getStateAccess().getCommaKeyword_5_1_1_0());
                            	    					
                            	    // InternalMyDsl.g:231:6: ( (lv_outgoingTransitions_8_0= ruleTransition ) )
                            	    // InternalMyDsl.g:232:7: (lv_outgoingTransitions_8_0= ruleTransition )
                            	    {
                            	    // InternalMyDsl.g:232:7: (lv_outgoingTransitions_8_0= ruleTransition )
                            	    // InternalMyDsl.g:233:8: lv_outgoingTransitions_8_0= ruleTransition
                            	    {

                            	    								newCompositeNode(grammarAccess.getStateAccess().getOutgoingTransitionsTransitionParserRuleCall_5_1_1_1_0());
                            	    							
                            	    pushFollow(FOLLOW_10);
                            	    lv_outgoingTransitions_8_0=ruleTransition();

                            	    state._fsp--;


                            	    								if (current==null) {
                            	    									current = createModelElementForParent(grammarAccess.getStateRule());
                            	    								}
                            	    								add(
                            	    									current,
                            	    									"outgoingTransitions",
                            	    									lv_outgoingTransitions_8_0,
                            	    									"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.Transition");
                            	    								afterParserOrEnumRuleCall();
                            	    							

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop4;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_9=(Token)match(input,16,FOLLOW_2); 

                    				newLeafNode(otherlv_9, grammarAccess.getStateAccess().getRightCurlyBracketKeyword_5_2());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleState"


    // $ANTLR start "entryRuleEString"
    // InternalMyDsl.g:261:1: entryRuleEString returns [String current=null] : iv_ruleEString= ruleEString EOF ;
    public final String entryRuleEString() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEString = null;


        try {
            // InternalMyDsl.g:261:47: (iv_ruleEString= ruleEString EOF )
            // InternalMyDsl.g:262:2: iv_ruleEString= ruleEString EOF
            {
             newCompositeNode(grammarAccess.getEStringRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEString=ruleEString();

            state._fsp--;

             current =iv_ruleEString.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEString"


    // $ANTLR start "ruleEString"
    // InternalMyDsl.g:268:1: ruleEString returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleEString() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_STRING_0=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalMyDsl.g:274:2: ( (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID ) )
            // InternalMyDsl.g:275:2: (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID )
            {
            // InternalMyDsl.g:275:2: (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==RULE_STRING) ) {
                alt7=1;
            }
            else if ( (LA7_0==RULE_ID) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // InternalMyDsl.g:276:3: this_STRING_0= RULE_STRING
                    {
                    this_STRING_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

                    			current.merge(this_STRING_0);
                    		

                    			newLeafNode(this_STRING_0, grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0());
                    		

                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:284:3: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FOLLOW_2); 

                    			current.merge(this_ID_1);
                    		

                    			newLeafNode(this_ID_1, grammarAccess.getEStringAccess().getIDTerminalRuleCall_1());
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEString"


    // $ANTLR start "entryRuleTransition"
    // InternalMyDsl.g:295:1: entryRuleTransition returns [EObject current=null] : iv_ruleTransition= ruleTransition EOF ;
    public final EObject entryRuleTransition() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTransition = null;


        try {
            // InternalMyDsl.g:295:51: (iv_ruleTransition= ruleTransition EOF )
            // InternalMyDsl.g:296:2: iv_ruleTransition= ruleTransition EOF
            {
             newCompositeNode(grammarAccess.getTransitionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTransition=ruleTransition();

            state._fsp--;

             current =iv_ruleTransition; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTransition"


    // $ANTLR start "ruleTransition"
    // InternalMyDsl.g:302:1: ruleTransition returns [EObject current=null] : (otherlv_0= 'Transition' otherlv_1= '{' ( (lv_trigger_2_0= ruleEString ) ) otherlv_3= '/' ( (lv_action_4_0= ruleAction ) ) ( (lv_newChar_5_0= ruleEString ) ) otherlv_6= ',' ( (lv_direction_7_0= ruleDirection ) ) otherlv_8= 'target' ( ( ruleEString ) ) otherlv_10= '}' ) ;
    public final EObject ruleTransition() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        AntlrDatatypeRuleToken lv_trigger_2_0 = null;

        Enumerator lv_action_4_0 = null;

        AntlrDatatypeRuleToken lv_newChar_5_0 = null;

        Enumerator lv_direction_7_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:308:2: ( (otherlv_0= 'Transition' otherlv_1= '{' ( (lv_trigger_2_0= ruleEString ) ) otherlv_3= '/' ( (lv_action_4_0= ruleAction ) ) ( (lv_newChar_5_0= ruleEString ) ) otherlv_6= ',' ( (lv_direction_7_0= ruleDirection ) ) otherlv_8= 'target' ( ( ruleEString ) ) otherlv_10= '}' ) )
            // InternalMyDsl.g:309:2: (otherlv_0= 'Transition' otherlv_1= '{' ( (lv_trigger_2_0= ruleEString ) ) otherlv_3= '/' ( (lv_action_4_0= ruleAction ) ) ( (lv_newChar_5_0= ruleEString ) ) otherlv_6= ',' ( (lv_direction_7_0= ruleDirection ) ) otherlv_8= 'target' ( ( ruleEString ) ) otherlv_10= '}' )
            {
            // InternalMyDsl.g:309:2: (otherlv_0= 'Transition' otherlv_1= '{' ( (lv_trigger_2_0= ruleEString ) ) otherlv_3= '/' ( (lv_action_4_0= ruleAction ) ) ( (lv_newChar_5_0= ruleEString ) ) otherlv_6= ',' ( (lv_direction_7_0= ruleDirection ) ) otherlv_8= 'target' ( ( ruleEString ) ) otherlv_10= '}' )
            // InternalMyDsl.g:310:3: otherlv_0= 'Transition' otherlv_1= '{' ( (lv_trigger_2_0= ruleEString ) ) otherlv_3= '/' ( (lv_action_4_0= ruleAction ) ) ( (lv_newChar_5_0= ruleEString ) ) otherlv_6= ',' ( (lv_direction_7_0= ruleDirection ) ) otherlv_8= 'target' ( ( ruleEString ) ) otherlv_10= '}'
            {
            otherlv_0=(Token)match(input,17,FOLLOW_12); 

            			newLeafNode(otherlv_0, grammarAccess.getTransitionAccess().getTransitionKeyword_0());
            		
            otherlv_1=(Token)match(input,15,FOLLOW_7); 

            			newLeafNode(otherlv_1, grammarAccess.getTransitionAccess().getLeftCurlyBracketKeyword_1());
            		
            // InternalMyDsl.g:318:3: ( (lv_trigger_2_0= ruleEString ) )
            // InternalMyDsl.g:319:4: (lv_trigger_2_0= ruleEString )
            {
            // InternalMyDsl.g:319:4: (lv_trigger_2_0= ruleEString )
            // InternalMyDsl.g:320:5: lv_trigger_2_0= ruleEString
            {

            					newCompositeNode(grammarAccess.getTransitionAccess().getTriggerEStringParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_13);
            lv_trigger_2_0=ruleEString();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTransitionRule());
            					}
            					set(
            						current,
            						"trigger",
            						lv_trigger_2_0,
            						"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.EString");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_3=(Token)match(input,18,FOLLOW_14); 

            			newLeafNode(otherlv_3, grammarAccess.getTransitionAccess().getSolidusKeyword_3());
            		
            // InternalMyDsl.g:341:3: ( (lv_action_4_0= ruleAction ) )
            // InternalMyDsl.g:342:4: (lv_action_4_0= ruleAction )
            {
            // InternalMyDsl.g:342:4: (lv_action_4_0= ruleAction )
            // InternalMyDsl.g:343:5: lv_action_4_0= ruleAction
            {

            					newCompositeNode(grammarAccess.getTransitionAccess().getActionActionEnumRuleCall_4_0());
            				
            pushFollow(FOLLOW_7);
            lv_action_4_0=ruleAction();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTransitionRule());
            					}
            					set(
            						current,
            						"action",
            						lv_action_4_0,
            						"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.Action");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalMyDsl.g:360:3: ( (lv_newChar_5_0= ruleEString ) )
            // InternalMyDsl.g:361:4: (lv_newChar_5_0= ruleEString )
            {
            // InternalMyDsl.g:361:4: (lv_newChar_5_0= ruleEString )
            // InternalMyDsl.g:362:5: lv_newChar_5_0= ruleEString
            {

            					newCompositeNode(grammarAccess.getTransitionAccess().getNewCharEStringParserRuleCall_5_0());
            				
            pushFollow(FOLLOW_15);
            lv_newChar_5_0=ruleEString();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTransitionRule());
            					}
            					set(
            						current,
            						"newChar",
            						lv_newChar_5_0,
            						"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.EString");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_6=(Token)match(input,11,FOLLOW_16); 

            			newLeafNode(otherlv_6, grammarAccess.getTransitionAccess().getCommaKeyword_6());
            		
            // InternalMyDsl.g:383:3: ( (lv_direction_7_0= ruleDirection ) )
            // InternalMyDsl.g:384:4: (lv_direction_7_0= ruleDirection )
            {
            // InternalMyDsl.g:384:4: (lv_direction_7_0= ruleDirection )
            // InternalMyDsl.g:385:5: lv_direction_7_0= ruleDirection
            {

            					newCompositeNode(grammarAccess.getTransitionAccess().getDirectionDirectionEnumRuleCall_7_0());
            				
            pushFollow(FOLLOW_17);
            lv_direction_7_0=ruleDirection();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTransitionRule());
            					}
            					set(
            						current,
            						"direction",
            						lv_direction_7_0,
            						"de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.MyDsl.Direction");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_8=(Token)match(input,19,FOLLOW_7); 

            			newLeafNode(otherlv_8, grammarAccess.getTransitionAccess().getTargetKeyword_8());
            		
            // InternalMyDsl.g:406:3: ( ( ruleEString ) )
            // InternalMyDsl.g:407:4: ( ruleEString )
            {
            // InternalMyDsl.g:407:4: ( ruleEString )
            // InternalMyDsl.g:408:5: ruleEString
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getTransitionRule());
            					}
            				

            					newCompositeNode(grammarAccess.getTransitionAccess().getTargetStateStateCrossReference_9_0());
            				
            pushFollow(FOLLOW_18);
            ruleEString();

            state._fsp--;


            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_10=(Token)match(input,16,FOLLOW_2); 

            			newLeafNode(otherlv_10, grammarAccess.getTransitionAccess().getRightCurlyBracketKeyword_10());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTransition"


    // $ANTLR start "ruleAction"
    // InternalMyDsl.g:430:1: ruleAction returns [Enumerator current=null] : ( (enumLiteral_0= 'WRITE' ) | (enumLiteral_1= 'ERASE' ) | (enumLiteral_2= 'NULL' ) ) ;
    public final Enumerator ruleAction() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;


        	enterRule();

        try {
            // InternalMyDsl.g:436:2: ( ( (enumLiteral_0= 'WRITE' ) | (enumLiteral_1= 'ERASE' ) | (enumLiteral_2= 'NULL' ) ) )
            // InternalMyDsl.g:437:2: ( (enumLiteral_0= 'WRITE' ) | (enumLiteral_1= 'ERASE' ) | (enumLiteral_2= 'NULL' ) )
            {
            // InternalMyDsl.g:437:2: ( (enumLiteral_0= 'WRITE' ) | (enumLiteral_1= 'ERASE' ) | (enumLiteral_2= 'NULL' ) )
            int alt8=3;
            switch ( input.LA(1) ) {
            case 20:
                {
                alt8=1;
                }
                break;
            case 21:
                {
                alt8=2;
                }
                break;
            case 22:
                {
                alt8=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // InternalMyDsl.g:438:3: (enumLiteral_0= 'WRITE' )
                    {
                    // InternalMyDsl.g:438:3: (enumLiteral_0= 'WRITE' )
                    // InternalMyDsl.g:439:4: enumLiteral_0= 'WRITE'
                    {
                    enumLiteral_0=(Token)match(input,20,FOLLOW_2); 

                    				current = grammarAccess.getActionAccess().getWRITEEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_0, grammarAccess.getActionAccess().getWRITEEnumLiteralDeclaration_0());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:446:3: (enumLiteral_1= 'ERASE' )
                    {
                    // InternalMyDsl.g:446:3: (enumLiteral_1= 'ERASE' )
                    // InternalMyDsl.g:447:4: enumLiteral_1= 'ERASE'
                    {
                    enumLiteral_1=(Token)match(input,21,FOLLOW_2); 

                    				current = grammarAccess.getActionAccess().getERASEEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_1, grammarAccess.getActionAccess().getERASEEnumLiteralDeclaration_1());
                    			

                    }


                    }
                    break;
                case 3 :
                    // InternalMyDsl.g:454:3: (enumLiteral_2= 'NULL' )
                    {
                    // InternalMyDsl.g:454:3: (enumLiteral_2= 'NULL' )
                    // InternalMyDsl.g:455:4: enumLiteral_2= 'NULL'
                    {
                    enumLiteral_2=(Token)match(input,22,FOLLOW_2); 

                    				current = grammarAccess.getActionAccess().getNULLEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_2, grammarAccess.getActionAccess().getNULLEnumLiteralDeclaration_2());
                    			

                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAction"


    // $ANTLR start "ruleDirection"
    // InternalMyDsl.g:465:1: ruleDirection returns [Enumerator current=null] : ( (enumLiteral_0= 'LEFT' ) | (enumLiteral_1= 'RIGHT' ) | (enumLiteral_2= 'NONE' ) ) ;
    public final Enumerator ruleDirection() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;


        	enterRule();

        try {
            // InternalMyDsl.g:471:2: ( ( (enumLiteral_0= 'LEFT' ) | (enumLiteral_1= 'RIGHT' ) | (enumLiteral_2= 'NONE' ) ) )
            // InternalMyDsl.g:472:2: ( (enumLiteral_0= 'LEFT' ) | (enumLiteral_1= 'RIGHT' ) | (enumLiteral_2= 'NONE' ) )
            {
            // InternalMyDsl.g:472:2: ( (enumLiteral_0= 'LEFT' ) | (enumLiteral_1= 'RIGHT' ) | (enumLiteral_2= 'NONE' ) )
            int alt9=3;
            switch ( input.LA(1) ) {
            case 23:
                {
                alt9=1;
                }
                break;
            case 24:
                {
                alt9=2;
                }
                break;
            case 25:
                {
                alt9=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // InternalMyDsl.g:473:3: (enumLiteral_0= 'LEFT' )
                    {
                    // InternalMyDsl.g:473:3: (enumLiteral_0= 'LEFT' )
                    // InternalMyDsl.g:474:4: enumLiteral_0= 'LEFT'
                    {
                    enumLiteral_0=(Token)match(input,23,FOLLOW_2); 

                    				current = grammarAccess.getDirectionAccess().getLEFTEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_0, grammarAccess.getDirectionAccess().getLEFTEnumLiteralDeclaration_0());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:481:3: (enumLiteral_1= 'RIGHT' )
                    {
                    // InternalMyDsl.g:481:3: (enumLiteral_1= 'RIGHT' )
                    // InternalMyDsl.g:482:4: enumLiteral_1= 'RIGHT'
                    {
                    enumLiteral_1=(Token)match(input,24,FOLLOW_2); 

                    				current = grammarAccess.getDirectionAccess().getRIGHTEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_1, grammarAccess.getDirectionAccess().getRIGHTEnumLiteralDeclaration_1());
                    			

                    }


                    }
                    break;
                case 3 :
                    // InternalMyDsl.g:489:3: (enumLiteral_2= 'NONE' )
                    {
                    // InternalMyDsl.g:489:3: (enumLiteral_2= 'NONE' )
                    // InternalMyDsl.g:490:4: enumLiteral_2= 'NONE'
                    {
                    enumLiteral_2=(Token)match(input,25,FOLLOW_2); 

                    				current = grammarAccess.getDirectionAccess().getNONEEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_2, grammarAccess.getDirectionAccess().getNONEEnumLiteralDeclaration_2());
                    			

                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDirection"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000007000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000000030L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000030000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000010800L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000700000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000003800000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000010000L});

}