package de.cau.cs.kieler.tutorials.klighd.turingvis.language.server

import de.cau.cs.kieler.klighd.lsp.KGraphLanguageClient
import de.cau.cs.kieler.klighd.lsp.launch.AbstractLsCreator
import java.util.List
import org.eclipse.xtext.ide.server.ILanguageServerExtension

class TuringvisLsCreator extends AbstractLsCreator {
	
	override getLanguageServerExtensions() {
		val List<ILanguageServerExtension> iLsExtensions = #[
			injector.getInstance(TuringvisLanguageServerExtension)
		]
		
		return iLsExtensions
	}
	
	override getRemoteInterface() {
		KGraphLanguageClient
	}
	
}