package de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.services.MyDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDslParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'WRITE'", "'ERASE'", "'NULL'", "'LEFT'", "'RIGHT'", "'NONE'", "','", "'State'", "'{'", "'}'", "'Transition'", "'/'", "'target'", "'initial'", "'final'"
    };
    public static final int RULE_STRING=4;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=6;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalMyDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMyDsl.g"; }


    	private MyDslGrammarAccess grammarAccess;

    	public void setGrammarAccess(MyDslGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleTuringMachine"
    // InternalMyDsl.g:53:1: entryRuleTuringMachine : ruleTuringMachine EOF ;
    public final void entryRuleTuringMachine() throws RecognitionException {
        try {
            // InternalMyDsl.g:54:1: ( ruleTuringMachine EOF )
            // InternalMyDsl.g:55:1: ruleTuringMachine EOF
            {
             before(grammarAccess.getTuringMachineRule()); 
            pushFollow(FOLLOW_1);
            ruleTuringMachine();

            state._fsp--;

             after(grammarAccess.getTuringMachineRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleTuringMachine"


    // $ANTLR start "ruleTuringMachine"
    // InternalMyDsl.g:62:1: ruleTuringMachine : ( ( rule__TuringMachine__Group__0 ) ) ;
    public final void ruleTuringMachine() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:66:2: ( ( ( rule__TuringMachine__Group__0 ) ) )
            // InternalMyDsl.g:67:2: ( ( rule__TuringMachine__Group__0 ) )
            {
            // InternalMyDsl.g:67:2: ( ( rule__TuringMachine__Group__0 ) )
            // InternalMyDsl.g:68:3: ( rule__TuringMachine__Group__0 )
            {
             before(grammarAccess.getTuringMachineAccess().getGroup()); 
            // InternalMyDsl.g:69:3: ( rule__TuringMachine__Group__0 )
            // InternalMyDsl.g:69:4: rule__TuringMachine__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__TuringMachine__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getTuringMachineAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleTuringMachine"


    // $ANTLR start "entryRuleState"
    // InternalMyDsl.g:78:1: entryRuleState : ruleState EOF ;
    public final void entryRuleState() throws RecognitionException {
        try {
            // InternalMyDsl.g:79:1: ( ruleState EOF )
            // InternalMyDsl.g:80:1: ruleState EOF
            {
             before(grammarAccess.getStateRule()); 
            pushFollow(FOLLOW_1);
            ruleState();

            state._fsp--;

             after(grammarAccess.getStateRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleState"


    // $ANTLR start "ruleState"
    // InternalMyDsl.g:87:1: ruleState : ( ( rule__State__Group__0 ) ) ;
    public final void ruleState() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:91:2: ( ( ( rule__State__Group__0 ) ) )
            // InternalMyDsl.g:92:2: ( ( rule__State__Group__0 ) )
            {
            // InternalMyDsl.g:92:2: ( ( rule__State__Group__0 ) )
            // InternalMyDsl.g:93:3: ( rule__State__Group__0 )
            {
             before(grammarAccess.getStateAccess().getGroup()); 
            // InternalMyDsl.g:94:3: ( rule__State__Group__0 )
            // InternalMyDsl.g:94:4: rule__State__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__State__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getStateAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleState"


    // $ANTLR start "entryRuleEString"
    // InternalMyDsl.g:103:1: entryRuleEString : ruleEString EOF ;
    public final void entryRuleEString() throws RecognitionException {
        try {
            // InternalMyDsl.g:104:1: ( ruleEString EOF )
            // InternalMyDsl.g:105:1: ruleEString EOF
            {
             before(grammarAccess.getEStringRule()); 
            pushFollow(FOLLOW_1);
            ruleEString();

            state._fsp--;

             after(grammarAccess.getEStringRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleEString"


    // $ANTLR start "ruleEString"
    // InternalMyDsl.g:112:1: ruleEString : ( ( rule__EString__Alternatives ) ) ;
    public final void ruleEString() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:116:2: ( ( ( rule__EString__Alternatives ) ) )
            // InternalMyDsl.g:117:2: ( ( rule__EString__Alternatives ) )
            {
            // InternalMyDsl.g:117:2: ( ( rule__EString__Alternatives ) )
            // InternalMyDsl.g:118:3: ( rule__EString__Alternatives )
            {
             before(grammarAccess.getEStringAccess().getAlternatives()); 
            // InternalMyDsl.g:119:3: ( rule__EString__Alternatives )
            // InternalMyDsl.g:119:4: rule__EString__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__EString__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getEStringAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleEString"


    // $ANTLR start "entryRuleTransition"
    // InternalMyDsl.g:128:1: entryRuleTransition : ruleTransition EOF ;
    public final void entryRuleTransition() throws RecognitionException {
        try {
            // InternalMyDsl.g:129:1: ( ruleTransition EOF )
            // InternalMyDsl.g:130:1: ruleTransition EOF
            {
             before(grammarAccess.getTransitionRule()); 
            pushFollow(FOLLOW_1);
            ruleTransition();

            state._fsp--;

             after(grammarAccess.getTransitionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleTransition"


    // $ANTLR start "ruleTransition"
    // InternalMyDsl.g:137:1: ruleTransition : ( ( rule__Transition__Group__0 ) ) ;
    public final void ruleTransition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:141:2: ( ( ( rule__Transition__Group__0 ) ) )
            // InternalMyDsl.g:142:2: ( ( rule__Transition__Group__0 ) )
            {
            // InternalMyDsl.g:142:2: ( ( rule__Transition__Group__0 ) )
            // InternalMyDsl.g:143:3: ( rule__Transition__Group__0 )
            {
             before(grammarAccess.getTransitionAccess().getGroup()); 
            // InternalMyDsl.g:144:3: ( rule__Transition__Group__0 )
            // InternalMyDsl.g:144:4: rule__Transition__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Transition__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getTransitionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleTransition"


    // $ANTLR start "ruleAction"
    // InternalMyDsl.g:153:1: ruleAction : ( ( rule__Action__Alternatives ) ) ;
    public final void ruleAction() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:157:1: ( ( ( rule__Action__Alternatives ) ) )
            // InternalMyDsl.g:158:2: ( ( rule__Action__Alternatives ) )
            {
            // InternalMyDsl.g:158:2: ( ( rule__Action__Alternatives ) )
            // InternalMyDsl.g:159:3: ( rule__Action__Alternatives )
            {
             before(grammarAccess.getActionAccess().getAlternatives()); 
            // InternalMyDsl.g:160:3: ( rule__Action__Alternatives )
            // InternalMyDsl.g:160:4: rule__Action__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Action__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getActionAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAction"


    // $ANTLR start "ruleDirection"
    // InternalMyDsl.g:169:1: ruleDirection : ( ( rule__Direction__Alternatives ) ) ;
    public final void ruleDirection() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:173:1: ( ( ( rule__Direction__Alternatives ) ) )
            // InternalMyDsl.g:174:2: ( ( rule__Direction__Alternatives ) )
            {
            // InternalMyDsl.g:174:2: ( ( rule__Direction__Alternatives ) )
            // InternalMyDsl.g:175:3: ( rule__Direction__Alternatives )
            {
             before(grammarAccess.getDirectionAccess().getAlternatives()); 
            // InternalMyDsl.g:176:3: ( rule__Direction__Alternatives )
            // InternalMyDsl.g:176:4: rule__Direction__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Direction__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getDirectionAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleDirection"


    // $ANTLR start "rule__EString__Alternatives"
    // InternalMyDsl.g:184:1: rule__EString__Alternatives : ( ( RULE_STRING ) | ( RULE_ID ) );
    public final void rule__EString__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:188:1: ( ( RULE_STRING ) | ( RULE_ID ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==RULE_STRING) ) {
                alt1=1;
            }
            else if ( (LA1_0==RULE_ID) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // InternalMyDsl.g:189:2: ( RULE_STRING )
                    {
                    // InternalMyDsl.g:189:2: ( RULE_STRING )
                    // InternalMyDsl.g:190:3: RULE_STRING
                    {
                     before(grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0()); 
                    match(input,RULE_STRING,FOLLOW_2); 
                     after(grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:195:2: ( RULE_ID )
                    {
                    // InternalMyDsl.g:195:2: ( RULE_ID )
                    // InternalMyDsl.g:196:3: RULE_ID
                    {
                     before(grammarAccess.getEStringAccess().getIDTerminalRuleCall_1()); 
                    match(input,RULE_ID,FOLLOW_2); 
                     after(grammarAccess.getEStringAccess().getIDTerminalRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EString__Alternatives"


    // $ANTLR start "rule__Action__Alternatives"
    // InternalMyDsl.g:205:1: rule__Action__Alternatives : ( ( ( 'WRITE' ) ) | ( ( 'ERASE' ) ) | ( ( 'NULL' ) ) );
    public final void rule__Action__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:209:1: ( ( ( 'WRITE' ) ) | ( ( 'ERASE' ) ) | ( ( 'NULL' ) ) )
            int alt2=3;
            switch ( input.LA(1) ) {
            case 11:
                {
                alt2=1;
                }
                break;
            case 12:
                {
                alt2=2;
                }
                break;
            case 13:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // InternalMyDsl.g:210:2: ( ( 'WRITE' ) )
                    {
                    // InternalMyDsl.g:210:2: ( ( 'WRITE' ) )
                    // InternalMyDsl.g:211:3: ( 'WRITE' )
                    {
                     before(grammarAccess.getActionAccess().getWRITEEnumLiteralDeclaration_0()); 
                    // InternalMyDsl.g:212:3: ( 'WRITE' )
                    // InternalMyDsl.g:212:4: 'WRITE'
                    {
                    match(input,11,FOLLOW_2); 

                    }

                     after(grammarAccess.getActionAccess().getWRITEEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:216:2: ( ( 'ERASE' ) )
                    {
                    // InternalMyDsl.g:216:2: ( ( 'ERASE' ) )
                    // InternalMyDsl.g:217:3: ( 'ERASE' )
                    {
                     before(grammarAccess.getActionAccess().getERASEEnumLiteralDeclaration_1()); 
                    // InternalMyDsl.g:218:3: ( 'ERASE' )
                    // InternalMyDsl.g:218:4: 'ERASE'
                    {
                    match(input,12,FOLLOW_2); 

                    }

                     after(grammarAccess.getActionAccess().getERASEEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalMyDsl.g:222:2: ( ( 'NULL' ) )
                    {
                    // InternalMyDsl.g:222:2: ( ( 'NULL' ) )
                    // InternalMyDsl.g:223:3: ( 'NULL' )
                    {
                     before(grammarAccess.getActionAccess().getNULLEnumLiteralDeclaration_2()); 
                    // InternalMyDsl.g:224:3: ( 'NULL' )
                    // InternalMyDsl.g:224:4: 'NULL'
                    {
                    match(input,13,FOLLOW_2); 

                    }

                     after(grammarAccess.getActionAccess().getNULLEnumLiteralDeclaration_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Action__Alternatives"


    // $ANTLR start "rule__Direction__Alternatives"
    // InternalMyDsl.g:232:1: rule__Direction__Alternatives : ( ( ( 'LEFT' ) ) | ( ( 'RIGHT' ) ) | ( ( 'NONE' ) ) );
    public final void rule__Direction__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:236:1: ( ( ( 'LEFT' ) ) | ( ( 'RIGHT' ) ) | ( ( 'NONE' ) ) )
            int alt3=3;
            switch ( input.LA(1) ) {
            case 14:
                {
                alt3=1;
                }
                break;
            case 15:
                {
                alt3=2;
                }
                break;
            case 16:
                {
                alt3=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }

            switch (alt3) {
                case 1 :
                    // InternalMyDsl.g:237:2: ( ( 'LEFT' ) )
                    {
                    // InternalMyDsl.g:237:2: ( ( 'LEFT' ) )
                    // InternalMyDsl.g:238:3: ( 'LEFT' )
                    {
                     before(grammarAccess.getDirectionAccess().getLEFTEnumLiteralDeclaration_0()); 
                    // InternalMyDsl.g:239:3: ( 'LEFT' )
                    // InternalMyDsl.g:239:4: 'LEFT'
                    {
                    match(input,14,FOLLOW_2); 

                    }

                     after(grammarAccess.getDirectionAccess().getLEFTEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMyDsl.g:243:2: ( ( 'RIGHT' ) )
                    {
                    // InternalMyDsl.g:243:2: ( ( 'RIGHT' ) )
                    // InternalMyDsl.g:244:3: ( 'RIGHT' )
                    {
                     before(grammarAccess.getDirectionAccess().getRIGHTEnumLiteralDeclaration_1()); 
                    // InternalMyDsl.g:245:3: ( 'RIGHT' )
                    // InternalMyDsl.g:245:4: 'RIGHT'
                    {
                    match(input,15,FOLLOW_2); 

                    }

                     after(grammarAccess.getDirectionAccess().getRIGHTEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalMyDsl.g:249:2: ( ( 'NONE' ) )
                    {
                    // InternalMyDsl.g:249:2: ( ( 'NONE' ) )
                    // InternalMyDsl.g:250:3: ( 'NONE' )
                    {
                     before(grammarAccess.getDirectionAccess().getNONEEnumLiteralDeclaration_2()); 
                    // InternalMyDsl.g:251:3: ( 'NONE' )
                    // InternalMyDsl.g:251:4: 'NONE'
                    {
                    match(input,16,FOLLOW_2); 

                    }

                     after(grammarAccess.getDirectionAccess().getNONEEnumLiteralDeclaration_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Direction__Alternatives"


    // $ANTLR start "rule__TuringMachine__Group__0"
    // InternalMyDsl.g:259:1: rule__TuringMachine__Group__0 : rule__TuringMachine__Group__0__Impl rule__TuringMachine__Group__1 ;
    public final void rule__TuringMachine__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:263:1: ( rule__TuringMachine__Group__0__Impl rule__TuringMachine__Group__1 )
            // InternalMyDsl.g:264:2: rule__TuringMachine__Group__0__Impl rule__TuringMachine__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__TuringMachine__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__TuringMachine__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group__0"


    // $ANTLR start "rule__TuringMachine__Group__0__Impl"
    // InternalMyDsl.g:271:1: rule__TuringMachine__Group__0__Impl : ( ( rule__TuringMachine__StatesAssignment_0 ) ) ;
    public final void rule__TuringMachine__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:275:1: ( ( ( rule__TuringMachine__StatesAssignment_0 ) ) )
            // InternalMyDsl.g:276:1: ( ( rule__TuringMachine__StatesAssignment_0 ) )
            {
            // InternalMyDsl.g:276:1: ( ( rule__TuringMachine__StatesAssignment_0 ) )
            // InternalMyDsl.g:277:2: ( rule__TuringMachine__StatesAssignment_0 )
            {
             before(grammarAccess.getTuringMachineAccess().getStatesAssignment_0()); 
            // InternalMyDsl.g:278:2: ( rule__TuringMachine__StatesAssignment_0 )
            // InternalMyDsl.g:278:3: rule__TuringMachine__StatesAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__TuringMachine__StatesAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getTuringMachineAccess().getStatesAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group__0__Impl"


    // $ANTLR start "rule__TuringMachine__Group__1"
    // InternalMyDsl.g:286:1: rule__TuringMachine__Group__1 : rule__TuringMachine__Group__1__Impl ;
    public final void rule__TuringMachine__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:290:1: ( rule__TuringMachine__Group__1__Impl )
            // InternalMyDsl.g:291:2: rule__TuringMachine__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__TuringMachine__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group__1"


    // $ANTLR start "rule__TuringMachine__Group__1__Impl"
    // InternalMyDsl.g:297:1: rule__TuringMachine__Group__1__Impl : ( ( rule__TuringMachine__Group_1__0 )* ) ;
    public final void rule__TuringMachine__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:301:1: ( ( ( rule__TuringMachine__Group_1__0 )* ) )
            // InternalMyDsl.g:302:1: ( ( rule__TuringMachine__Group_1__0 )* )
            {
            // InternalMyDsl.g:302:1: ( ( rule__TuringMachine__Group_1__0 )* )
            // InternalMyDsl.g:303:2: ( rule__TuringMachine__Group_1__0 )*
            {
             before(grammarAccess.getTuringMachineAccess().getGroup_1()); 
            // InternalMyDsl.g:304:2: ( rule__TuringMachine__Group_1__0 )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==17) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // InternalMyDsl.g:304:3: rule__TuringMachine__Group_1__0
            	    {
            	    pushFollow(FOLLOW_4);
            	    rule__TuringMachine__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

             after(grammarAccess.getTuringMachineAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group__1__Impl"


    // $ANTLR start "rule__TuringMachine__Group_1__0"
    // InternalMyDsl.g:313:1: rule__TuringMachine__Group_1__0 : rule__TuringMachine__Group_1__0__Impl rule__TuringMachine__Group_1__1 ;
    public final void rule__TuringMachine__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:317:1: ( rule__TuringMachine__Group_1__0__Impl rule__TuringMachine__Group_1__1 )
            // InternalMyDsl.g:318:2: rule__TuringMachine__Group_1__0__Impl rule__TuringMachine__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__TuringMachine__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__TuringMachine__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group_1__0"


    // $ANTLR start "rule__TuringMachine__Group_1__0__Impl"
    // InternalMyDsl.g:325:1: rule__TuringMachine__Group_1__0__Impl : ( ',' ) ;
    public final void rule__TuringMachine__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:329:1: ( ( ',' ) )
            // InternalMyDsl.g:330:1: ( ',' )
            {
            // InternalMyDsl.g:330:1: ( ',' )
            // InternalMyDsl.g:331:2: ','
            {
             before(grammarAccess.getTuringMachineAccess().getCommaKeyword_1_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getTuringMachineAccess().getCommaKeyword_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group_1__0__Impl"


    // $ANTLR start "rule__TuringMachine__Group_1__1"
    // InternalMyDsl.g:340:1: rule__TuringMachine__Group_1__1 : rule__TuringMachine__Group_1__1__Impl ;
    public final void rule__TuringMachine__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:344:1: ( rule__TuringMachine__Group_1__1__Impl )
            // InternalMyDsl.g:345:2: rule__TuringMachine__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__TuringMachine__Group_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group_1__1"


    // $ANTLR start "rule__TuringMachine__Group_1__1__Impl"
    // InternalMyDsl.g:351:1: rule__TuringMachine__Group_1__1__Impl : ( ( rule__TuringMachine__StatesAssignment_1_1 ) ) ;
    public final void rule__TuringMachine__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:355:1: ( ( ( rule__TuringMachine__StatesAssignment_1_1 ) ) )
            // InternalMyDsl.g:356:1: ( ( rule__TuringMachine__StatesAssignment_1_1 ) )
            {
            // InternalMyDsl.g:356:1: ( ( rule__TuringMachine__StatesAssignment_1_1 ) )
            // InternalMyDsl.g:357:2: ( rule__TuringMachine__StatesAssignment_1_1 )
            {
             before(grammarAccess.getTuringMachineAccess().getStatesAssignment_1_1()); 
            // InternalMyDsl.g:358:2: ( rule__TuringMachine__StatesAssignment_1_1 )
            // InternalMyDsl.g:358:3: rule__TuringMachine__StatesAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__TuringMachine__StatesAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getTuringMachineAccess().getStatesAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__Group_1__1__Impl"


    // $ANTLR start "rule__State__Group__0"
    // InternalMyDsl.g:367:1: rule__State__Group__0 : rule__State__Group__0__Impl rule__State__Group__1 ;
    public final void rule__State__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:371:1: ( rule__State__Group__0__Impl rule__State__Group__1 )
            // InternalMyDsl.g:372:2: rule__State__Group__0__Impl rule__State__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__State__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__0"


    // $ANTLR start "rule__State__Group__0__Impl"
    // InternalMyDsl.g:379:1: rule__State__Group__0__Impl : ( () ) ;
    public final void rule__State__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:383:1: ( ( () ) )
            // InternalMyDsl.g:384:1: ( () )
            {
            // InternalMyDsl.g:384:1: ( () )
            // InternalMyDsl.g:385:2: ()
            {
             before(grammarAccess.getStateAccess().getStateAction_0()); 
            // InternalMyDsl.g:386:2: ()
            // InternalMyDsl.g:386:3: 
            {
            }

             after(grammarAccess.getStateAccess().getStateAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__0__Impl"


    // $ANTLR start "rule__State__Group__1"
    // InternalMyDsl.g:394:1: rule__State__Group__1 : rule__State__Group__1__Impl rule__State__Group__2 ;
    public final void rule__State__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:398:1: ( rule__State__Group__1__Impl rule__State__Group__2 )
            // InternalMyDsl.g:399:2: rule__State__Group__1__Impl rule__State__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__State__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__1"


    // $ANTLR start "rule__State__Group__1__Impl"
    // InternalMyDsl.g:406:1: rule__State__Group__1__Impl : ( ( rule__State__InitialAssignment_1 )? ) ;
    public final void rule__State__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:410:1: ( ( ( rule__State__InitialAssignment_1 )? ) )
            // InternalMyDsl.g:411:1: ( ( rule__State__InitialAssignment_1 )? )
            {
            // InternalMyDsl.g:411:1: ( ( rule__State__InitialAssignment_1 )? )
            // InternalMyDsl.g:412:2: ( rule__State__InitialAssignment_1 )?
            {
             before(grammarAccess.getStateAccess().getInitialAssignment_1()); 
            // InternalMyDsl.g:413:2: ( rule__State__InitialAssignment_1 )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==24) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalMyDsl.g:413:3: rule__State__InitialAssignment_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__State__InitialAssignment_1();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getStateAccess().getInitialAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__1__Impl"


    // $ANTLR start "rule__State__Group__2"
    // InternalMyDsl.g:421:1: rule__State__Group__2 : rule__State__Group__2__Impl rule__State__Group__3 ;
    public final void rule__State__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:425:1: ( rule__State__Group__2__Impl rule__State__Group__3 )
            // InternalMyDsl.g:426:2: rule__State__Group__2__Impl rule__State__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__State__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__2"


    // $ANTLR start "rule__State__Group__2__Impl"
    // InternalMyDsl.g:433:1: rule__State__Group__2__Impl : ( ( rule__State__FinalAssignment_2 )? ) ;
    public final void rule__State__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:437:1: ( ( ( rule__State__FinalAssignment_2 )? ) )
            // InternalMyDsl.g:438:1: ( ( rule__State__FinalAssignment_2 )? )
            {
            // InternalMyDsl.g:438:1: ( ( rule__State__FinalAssignment_2 )? )
            // InternalMyDsl.g:439:2: ( rule__State__FinalAssignment_2 )?
            {
             before(grammarAccess.getStateAccess().getFinalAssignment_2()); 
            // InternalMyDsl.g:440:2: ( rule__State__FinalAssignment_2 )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==25) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalMyDsl.g:440:3: rule__State__FinalAssignment_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__State__FinalAssignment_2();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getStateAccess().getFinalAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__2__Impl"


    // $ANTLR start "rule__State__Group__3"
    // InternalMyDsl.g:448:1: rule__State__Group__3 : rule__State__Group__3__Impl rule__State__Group__4 ;
    public final void rule__State__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:452:1: ( rule__State__Group__3__Impl rule__State__Group__4 )
            // InternalMyDsl.g:453:2: rule__State__Group__3__Impl rule__State__Group__4
            {
            pushFollow(FOLLOW_6);
            rule__State__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__3"


    // $ANTLR start "rule__State__Group__3__Impl"
    // InternalMyDsl.g:460:1: rule__State__Group__3__Impl : ( 'State' ) ;
    public final void rule__State__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:464:1: ( ( 'State' ) )
            // InternalMyDsl.g:465:1: ( 'State' )
            {
            // InternalMyDsl.g:465:1: ( 'State' )
            // InternalMyDsl.g:466:2: 'State'
            {
             before(grammarAccess.getStateAccess().getStateKeyword_3()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getStateAccess().getStateKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__3__Impl"


    // $ANTLR start "rule__State__Group__4"
    // InternalMyDsl.g:475:1: rule__State__Group__4 : rule__State__Group__4__Impl rule__State__Group__5 ;
    public final void rule__State__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:479:1: ( rule__State__Group__4__Impl rule__State__Group__5 )
            // InternalMyDsl.g:480:2: rule__State__Group__4__Impl rule__State__Group__5
            {
            pushFollow(FOLLOW_7);
            rule__State__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__4"


    // $ANTLR start "rule__State__Group__4__Impl"
    // InternalMyDsl.g:487:1: rule__State__Group__4__Impl : ( ( rule__State__NameAssignment_4 ) ) ;
    public final void rule__State__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:491:1: ( ( ( rule__State__NameAssignment_4 ) ) )
            // InternalMyDsl.g:492:1: ( ( rule__State__NameAssignment_4 ) )
            {
            // InternalMyDsl.g:492:1: ( ( rule__State__NameAssignment_4 ) )
            // InternalMyDsl.g:493:2: ( rule__State__NameAssignment_4 )
            {
             before(grammarAccess.getStateAccess().getNameAssignment_4()); 
            // InternalMyDsl.g:494:2: ( rule__State__NameAssignment_4 )
            // InternalMyDsl.g:494:3: rule__State__NameAssignment_4
            {
            pushFollow(FOLLOW_2);
            rule__State__NameAssignment_4();

            state._fsp--;


            }

             after(grammarAccess.getStateAccess().getNameAssignment_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__4__Impl"


    // $ANTLR start "rule__State__Group__5"
    // InternalMyDsl.g:502:1: rule__State__Group__5 : rule__State__Group__5__Impl ;
    public final void rule__State__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:506:1: ( rule__State__Group__5__Impl )
            // InternalMyDsl.g:507:2: rule__State__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__State__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__5"


    // $ANTLR start "rule__State__Group__5__Impl"
    // InternalMyDsl.g:513:1: rule__State__Group__5__Impl : ( ( rule__State__Group_5__0 )? ) ;
    public final void rule__State__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:517:1: ( ( ( rule__State__Group_5__0 )? ) )
            // InternalMyDsl.g:518:1: ( ( rule__State__Group_5__0 )? )
            {
            // InternalMyDsl.g:518:1: ( ( rule__State__Group_5__0 )? )
            // InternalMyDsl.g:519:2: ( rule__State__Group_5__0 )?
            {
             before(grammarAccess.getStateAccess().getGroup_5()); 
            // InternalMyDsl.g:520:2: ( rule__State__Group_5__0 )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==19) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // InternalMyDsl.g:520:3: rule__State__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__State__Group_5__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getStateAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group__5__Impl"


    // $ANTLR start "rule__State__Group_5__0"
    // InternalMyDsl.g:529:1: rule__State__Group_5__0 : rule__State__Group_5__0__Impl rule__State__Group_5__1 ;
    public final void rule__State__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:533:1: ( rule__State__Group_5__0__Impl rule__State__Group_5__1 )
            // InternalMyDsl.g:534:2: rule__State__Group_5__0__Impl rule__State__Group_5__1
            {
            pushFollow(FOLLOW_8);
            rule__State__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5__0"


    // $ANTLR start "rule__State__Group_5__0__Impl"
    // InternalMyDsl.g:541:1: rule__State__Group_5__0__Impl : ( '{' ) ;
    public final void rule__State__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:545:1: ( ( '{' ) )
            // InternalMyDsl.g:546:1: ( '{' )
            {
            // InternalMyDsl.g:546:1: ( '{' )
            // InternalMyDsl.g:547:2: '{'
            {
             before(grammarAccess.getStateAccess().getLeftCurlyBracketKeyword_5_0()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getStateAccess().getLeftCurlyBracketKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5__0__Impl"


    // $ANTLR start "rule__State__Group_5__1"
    // InternalMyDsl.g:556:1: rule__State__Group_5__1 : rule__State__Group_5__1__Impl rule__State__Group_5__2 ;
    public final void rule__State__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:560:1: ( rule__State__Group_5__1__Impl rule__State__Group_5__2 )
            // InternalMyDsl.g:561:2: rule__State__Group_5__1__Impl rule__State__Group_5__2
            {
            pushFollow(FOLLOW_8);
            rule__State__Group_5__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group_5__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5__1"


    // $ANTLR start "rule__State__Group_5__1__Impl"
    // InternalMyDsl.g:568:1: rule__State__Group_5__1__Impl : ( ( rule__State__Group_5_1__0 )? ) ;
    public final void rule__State__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:572:1: ( ( ( rule__State__Group_5_1__0 )? ) )
            // InternalMyDsl.g:573:1: ( ( rule__State__Group_5_1__0 )? )
            {
            // InternalMyDsl.g:573:1: ( ( rule__State__Group_5_1__0 )? )
            // InternalMyDsl.g:574:2: ( rule__State__Group_5_1__0 )?
            {
             before(grammarAccess.getStateAccess().getGroup_5_1()); 
            // InternalMyDsl.g:575:2: ( rule__State__Group_5_1__0 )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==21) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // InternalMyDsl.g:575:3: rule__State__Group_5_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__State__Group_5_1__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getStateAccess().getGroup_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5__1__Impl"


    // $ANTLR start "rule__State__Group_5__2"
    // InternalMyDsl.g:583:1: rule__State__Group_5__2 : rule__State__Group_5__2__Impl ;
    public final void rule__State__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:587:1: ( rule__State__Group_5__2__Impl )
            // InternalMyDsl.g:588:2: rule__State__Group_5__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__State__Group_5__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5__2"


    // $ANTLR start "rule__State__Group_5__2__Impl"
    // InternalMyDsl.g:594:1: rule__State__Group_5__2__Impl : ( '}' ) ;
    public final void rule__State__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:598:1: ( ( '}' ) )
            // InternalMyDsl.g:599:1: ( '}' )
            {
            // InternalMyDsl.g:599:1: ( '}' )
            // InternalMyDsl.g:600:2: '}'
            {
             before(grammarAccess.getStateAccess().getRightCurlyBracketKeyword_5_2()); 
            match(input,20,FOLLOW_2); 
             after(grammarAccess.getStateAccess().getRightCurlyBracketKeyword_5_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5__2__Impl"


    // $ANTLR start "rule__State__Group_5_1__0"
    // InternalMyDsl.g:610:1: rule__State__Group_5_1__0 : rule__State__Group_5_1__0__Impl rule__State__Group_5_1__1 ;
    public final void rule__State__Group_5_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:614:1: ( rule__State__Group_5_1__0__Impl rule__State__Group_5_1__1 )
            // InternalMyDsl.g:615:2: rule__State__Group_5_1__0__Impl rule__State__Group_5_1__1
            {
            pushFollow(FOLLOW_3);
            rule__State__Group_5_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group_5_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1__0"


    // $ANTLR start "rule__State__Group_5_1__0__Impl"
    // InternalMyDsl.g:622:1: rule__State__Group_5_1__0__Impl : ( ( rule__State__OutgoingTransitionsAssignment_5_1_0 ) ) ;
    public final void rule__State__Group_5_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:626:1: ( ( ( rule__State__OutgoingTransitionsAssignment_5_1_0 ) ) )
            // InternalMyDsl.g:627:1: ( ( rule__State__OutgoingTransitionsAssignment_5_1_0 ) )
            {
            // InternalMyDsl.g:627:1: ( ( rule__State__OutgoingTransitionsAssignment_5_1_0 ) )
            // InternalMyDsl.g:628:2: ( rule__State__OutgoingTransitionsAssignment_5_1_0 )
            {
             before(grammarAccess.getStateAccess().getOutgoingTransitionsAssignment_5_1_0()); 
            // InternalMyDsl.g:629:2: ( rule__State__OutgoingTransitionsAssignment_5_1_0 )
            // InternalMyDsl.g:629:3: rule__State__OutgoingTransitionsAssignment_5_1_0
            {
            pushFollow(FOLLOW_2);
            rule__State__OutgoingTransitionsAssignment_5_1_0();

            state._fsp--;


            }

             after(grammarAccess.getStateAccess().getOutgoingTransitionsAssignment_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1__0__Impl"


    // $ANTLR start "rule__State__Group_5_1__1"
    // InternalMyDsl.g:637:1: rule__State__Group_5_1__1 : rule__State__Group_5_1__1__Impl ;
    public final void rule__State__Group_5_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:641:1: ( rule__State__Group_5_1__1__Impl )
            // InternalMyDsl.g:642:2: rule__State__Group_5_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__State__Group_5_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1__1"


    // $ANTLR start "rule__State__Group_5_1__1__Impl"
    // InternalMyDsl.g:648:1: rule__State__Group_5_1__1__Impl : ( ( rule__State__Group_5_1_1__0 )* ) ;
    public final void rule__State__Group_5_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:652:1: ( ( ( rule__State__Group_5_1_1__0 )* ) )
            // InternalMyDsl.g:653:1: ( ( rule__State__Group_5_1_1__0 )* )
            {
            // InternalMyDsl.g:653:1: ( ( rule__State__Group_5_1_1__0 )* )
            // InternalMyDsl.g:654:2: ( rule__State__Group_5_1_1__0 )*
            {
             before(grammarAccess.getStateAccess().getGroup_5_1_1()); 
            // InternalMyDsl.g:655:2: ( rule__State__Group_5_1_1__0 )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( (LA9_0==17) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // InternalMyDsl.g:655:3: rule__State__Group_5_1_1__0
            	    {
            	    pushFollow(FOLLOW_4);
            	    rule__State__Group_5_1_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);

             after(grammarAccess.getStateAccess().getGroup_5_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1__1__Impl"


    // $ANTLR start "rule__State__Group_5_1_1__0"
    // InternalMyDsl.g:664:1: rule__State__Group_5_1_1__0 : rule__State__Group_5_1_1__0__Impl rule__State__Group_5_1_1__1 ;
    public final void rule__State__Group_5_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:668:1: ( rule__State__Group_5_1_1__0__Impl rule__State__Group_5_1_1__1 )
            // InternalMyDsl.g:669:2: rule__State__Group_5_1_1__0__Impl rule__State__Group_5_1_1__1
            {
            pushFollow(FOLLOW_9);
            rule__State__Group_5_1_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__State__Group_5_1_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1_1__0"


    // $ANTLR start "rule__State__Group_5_1_1__0__Impl"
    // InternalMyDsl.g:676:1: rule__State__Group_5_1_1__0__Impl : ( ',' ) ;
    public final void rule__State__Group_5_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:680:1: ( ( ',' ) )
            // InternalMyDsl.g:681:1: ( ',' )
            {
            // InternalMyDsl.g:681:1: ( ',' )
            // InternalMyDsl.g:682:2: ','
            {
             before(grammarAccess.getStateAccess().getCommaKeyword_5_1_1_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getStateAccess().getCommaKeyword_5_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1_1__0__Impl"


    // $ANTLR start "rule__State__Group_5_1_1__1"
    // InternalMyDsl.g:691:1: rule__State__Group_5_1_1__1 : rule__State__Group_5_1_1__1__Impl ;
    public final void rule__State__Group_5_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:695:1: ( rule__State__Group_5_1_1__1__Impl )
            // InternalMyDsl.g:696:2: rule__State__Group_5_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__State__Group_5_1_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1_1__1"


    // $ANTLR start "rule__State__Group_5_1_1__1__Impl"
    // InternalMyDsl.g:702:1: rule__State__Group_5_1_1__1__Impl : ( ( rule__State__OutgoingTransitionsAssignment_5_1_1_1 ) ) ;
    public final void rule__State__Group_5_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:706:1: ( ( ( rule__State__OutgoingTransitionsAssignment_5_1_1_1 ) ) )
            // InternalMyDsl.g:707:1: ( ( rule__State__OutgoingTransitionsAssignment_5_1_1_1 ) )
            {
            // InternalMyDsl.g:707:1: ( ( rule__State__OutgoingTransitionsAssignment_5_1_1_1 ) )
            // InternalMyDsl.g:708:2: ( rule__State__OutgoingTransitionsAssignment_5_1_1_1 )
            {
             before(grammarAccess.getStateAccess().getOutgoingTransitionsAssignment_5_1_1_1()); 
            // InternalMyDsl.g:709:2: ( rule__State__OutgoingTransitionsAssignment_5_1_1_1 )
            // InternalMyDsl.g:709:3: rule__State__OutgoingTransitionsAssignment_5_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__State__OutgoingTransitionsAssignment_5_1_1_1();

            state._fsp--;


            }

             after(grammarAccess.getStateAccess().getOutgoingTransitionsAssignment_5_1_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__Group_5_1_1__1__Impl"


    // $ANTLR start "rule__Transition__Group__0"
    // InternalMyDsl.g:718:1: rule__Transition__Group__0 : rule__Transition__Group__0__Impl rule__Transition__Group__1 ;
    public final void rule__Transition__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:722:1: ( rule__Transition__Group__0__Impl rule__Transition__Group__1 )
            // InternalMyDsl.g:723:2: rule__Transition__Group__0__Impl rule__Transition__Group__1
            {
            pushFollow(FOLLOW_7);
            rule__Transition__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__0"


    // $ANTLR start "rule__Transition__Group__0__Impl"
    // InternalMyDsl.g:730:1: rule__Transition__Group__0__Impl : ( 'Transition' ) ;
    public final void rule__Transition__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:734:1: ( ( 'Transition' ) )
            // InternalMyDsl.g:735:1: ( 'Transition' )
            {
            // InternalMyDsl.g:735:1: ( 'Transition' )
            // InternalMyDsl.g:736:2: 'Transition'
            {
             before(grammarAccess.getTransitionAccess().getTransitionKeyword_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getTransitionAccess().getTransitionKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__0__Impl"


    // $ANTLR start "rule__Transition__Group__1"
    // InternalMyDsl.g:745:1: rule__Transition__Group__1 : rule__Transition__Group__1__Impl rule__Transition__Group__2 ;
    public final void rule__Transition__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:749:1: ( rule__Transition__Group__1__Impl rule__Transition__Group__2 )
            // InternalMyDsl.g:750:2: rule__Transition__Group__1__Impl rule__Transition__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__Transition__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__1"


    // $ANTLR start "rule__Transition__Group__1__Impl"
    // InternalMyDsl.g:757:1: rule__Transition__Group__1__Impl : ( '{' ) ;
    public final void rule__Transition__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:761:1: ( ( '{' ) )
            // InternalMyDsl.g:762:1: ( '{' )
            {
            // InternalMyDsl.g:762:1: ( '{' )
            // InternalMyDsl.g:763:2: '{'
            {
             before(grammarAccess.getTransitionAccess().getLeftCurlyBracketKeyword_1()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getTransitionAccess().getLeftCurlyBracketKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__1__Impl"


    // $ANTLR start "rule__Transition__Group__2"
    // InternalMyDsl.g:772:1: rule__Transition__Group__2 : rule__Transition__Group__2__Impl rule__Transition__Group__3 ;
    public final void rule__Transition__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:776:1: ( rule__Transition__Group__2__Impl rule__Transition__Group__3 )
            // InternalMyDsl.g:777:2: rule__Transition__Group__2__Impl rule__Transition__Group__3
            {
            pushFollow(FOLLOW_10);
            rule__Transition__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__2"


    // $ANTLR start "rule__Transition__Group__2__Impl"
    // InternalMyDsl.g:784:1: rule__Transition__Group__2__Impl : ( ( rule__Transition__TriggerAssignment_2 ) ) ;
    public final void rule__Transition__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:788:1: ( ( ( rule__Transition__TriggerAssignment_2 ) ) )
            // InternalMyDsl.g:789:1: ( ( rule__Transition__TriggerAssignment_2 ) )
            {
            // InternalMyDsl.g:789:1: ( ( rule__Transition__TriggerAssignment_2 ) )
            // InternalMyDsl.g:790:2: ( rule__Transition__TriggerAssignment_2 )
            {
             before(grammarAccess.getTransitionAccess().getTriggerAssignment_2()); 
            // InternalMyDsl.g:791:2: ( rule__Transition__TriggerAssignment_2 )
            // InternalMyDsl.g:791:3: rule__Transition__TriggerAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__Transition__TriggerAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getTransitionAccess().getTriggerAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__2__Impl"


    // $ANTLR start "rule__Transition__Group__3"
    // InternalMyDsl.g:799:1: rule__Transition__Group__3 : rule__Transition__Group__3__Impl rule__Transition__Group__4 ;
    public final void rule__Transition__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:803:1: ( rule__Transition__Group__3__Impl rule__Transition__Group__4 )
            // InternalMyDsl.g:804:2: rule__Transition__Group__3__Impl rule__Transition__Group__4
            {
            pushFollow(FOLLOW_11);
            rule__Transition__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__3"


    // $ANTLR start "rule__Transition__Group__3__Impl"
    // InternalMyDsl.g:811:1: rule__Transition__Group__3__Impl : ( '/' ) ;
    public final void rule__Transition__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:815:1: ( ( '/' ) )
            // InternalMyDsl.g:816:1: ( '/' )
            {
            // InternalMyDsl.g:816:1: ( '/' )
            // InternalMyDsl.g:817:2: '/'
            {
             before(grammarAccess.getTransitionAccess().getSolidusKeyword_3()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getTransitionAccess().getSolidusKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__3__Impl"


    // $ANTLR start "rule__Transition__Group__4"
    // InternalMyDsl.g:826:1: rule__Transition__Group__4 : rule__Transition__Group__4__Impl rule__Transition__Group__5 ;
    public final void rule__Transition__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:830:1: ( rule__Transition__Group__4__Impl rule__Transition__Group__5 )
            // InternalMyDsl.g:831:2: rule__Transition__Group__4__Impl rule__Transition__Group__5
            {
            pushFollow(FOLLOW_6);
            rule__Transition__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__4"


    // $ANTLR start "rule__Transition__Group__4__Impl"
    // InternalMyDsl.g:838:1: rule__Transition__Group__4__Impl : ( ( rule__Transition__ActionAssignment_4 ) ) ;
    public final void rule__Transition__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:842:1: ( ( ( rule__Transition__ActionAssignment_4 ) ) )
            // InternalMyDsl.g:843:1: ( ( rule__Transition__ActionAssignment_4 ) )
            {
            // InternalMyDsl.g:843:1: ( ( rule__Transition__ActionAssignment_4 ) )
            // InternalMyDsl.g:844:2: ( rule__Transition__ActionAssignment_4 )
            {
             before(grammarAccess.getTransitionAccess().getActionAssignment_4()); 
            // InternalMyDsl.g:845:2: ( rule__Transition__ActionAssignment_4 )
            // InternalMyDsl.g:845:3: rule__Transition__ActionAssignment_4
            {
            pushFollow(FOLLOW_2);
            rule__Transition__ActionAssignment_4();

            state._fsp--;


            }

             after(grammarAccess.getTransitionAccess().getActionAssignment_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__4__Impl"


    // $ANTLR start "rule__Transition__Group__5"
    // InternalMyDsl.g:853:1: rule__Transition__Group__5 : rule__Transition__Group__5__Impl rule__Transition__Group__6 ;
    public final void rule__Transition__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:857:1: ( rule__Transition__Group__5__Impl rule__Transition__Group__6 )
            // InternalMyDsl.g:858:2: rule__Transition__Group__5__Impl rule__Transition__Group__6
            {
            pushFollow(FOLLOW_3);
            rule__Transition__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__5"


    // $ANTLR start "rule__Transition__Group__5__Impl"
    // InternalMyDsl.g:865:1: rule__Transition__Group__5__Impl : ( ( rule__Transition__NewCharAssignment_5 ) ) ;
    public final void rule__Transition__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:869:1: ( ( ( rule__Transition__NewCharAssignment_5 ) ) )
            // InternalMyDsl.g:870:1: ( ( rule__Transition__NewCharAssignment_5 ) )
            {
            // InternalMyDsl.g:870:1: ( ( rule__Transition__NewCharAssignment_5 ) )
            // InternalMyDsl.g:871:2: ( rule__Transition__NewCharAssignment_5 )
            {
             before(grammarAccess.getTransitionAccess().getNewCharAssignment_5()); 
            // InternalMyDsl.g:872:2: ( rule__Transition__NewCharAssignment_5 )
            // InternalMyDsl.g:872:3: rule__Transition__NewCharAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__Transition__NewCharAssignment_5();

            state._fsp--;


            }

             after(grammarAccess.getTransitionAccess().getNewCharAssignment_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__5__Impl"


    // $ANTLR start "rule__Transition__Group__6"
    // InternalMyDsl.g:880:1: rule__Transition__Group__6 : rule__Transition__Group__6__Impl rule__Transition__Group__7 ;
    public final void rule__Transition__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:884:1: ( rule__Transition__Group__6__Impl rule__Transition__Group__7 )
            // InternalMyDsl.g:885:2: rule__Transition__Group__6__Impl rule__Transition__Group__7
            {
            pushFollow(FOLLOW_12);
            rule__Transition__Group__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__6"


    // $ANTLR start "rule__Transition__Group__6__Impl"
    // InternalMyDsl.g:892:1: rule__Transition__Group__6__Impl : ( ',' ) ;
    public final void rule__Transition__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:896:1: ( ( ',' ) )
            // InternalMyDsl.g:897:1: ( ',' )
            {
            // InternalMyDsl.g:897:1: ( ',' )
            // InternalMyDsl.g:898:2: ','
            {
             before(grammarAccess.getTransitionAccess().getCommaKeyword_6()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getTransitionAccess().getCommaKeyword_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__6__Impl"


    // $ANTLR start "rule__Transition__Group__7"
    // InternalMyDsl.g:907:1: rule__Transition__Group__7 : rule__Transition__Group__7__Impl rule__Transition__Group__8 ;
    public final void rule__Transition__Group__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:911:1: ( rule__Transition__Group__7__Impl rule__Transition__Group__8 )
            // InternalMyDsl.g:912:2: rule__Transition__Group__7__Impl rule__Transition__Group__8
            {
            pushFollow(FOLLOW_13);
            rule__Transition__Group__7__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__8();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__7"


    // $ANTLR start "rule__Transition__Group__7__Impl"
    // InternalMyDsl.g:919:1: rule__Transition__Group__7__Impl : ( ( rule__Transition__DirectionAssignment_7 ) ) ;
    public final void rule__Transition__Group__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:923:1: ( ( ( rule__Transition__DirectionAssignment_7 ) ) )
            // InternalMyDsl.g:924:1: ( ( rule__Transition__DirectionAssignment_7 ) )
            {
            // InternalMyDsl.g:924:1: ( ( rule__Transition__DirectionAssignment_7 ) )
            // InternalMyDsl.g:925:2: ( rule__Transition__DirectionAssignment_7 )
            {
             before(grammarAccess.getTransitionAccess().getDirectionAssignment_7()); 
            // InternalMyDsl.g:926:2: ( rule__Transition__DirectionAssignment_7 )
            // InternalMyDsl.g:926:3: rule__Transition__DirectionAssignment_7
            {
            pushFollow(FOLLOW_2);
            rule__Transition__DirectionAssignment_7();

            state._fsp--;


            }

             after(grammarAccess.getTransitionAccess().getDirectionAssignment_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__7__Impl"


    // $ANTLR start "rule__Transition__Group__8"
    // InternalMyDsl.g:934:1: rule__Transition__Group__8 : rule__Transition__Group__8__Impl rule__Transition__Group__9 ;
    public final void rule__Transition__Group__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:938:1: ( rule__Transition__Group__8__Impl rule__Transition__Group__9 )
            // InternalMyDsl.g:939:2: rule__Transition__Group__8__Impl rule__Transition__Group__9
            {
            pushFollow(FOLLOW_6);
            rule__Transition__Group__8__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__9();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__8"


    // $ANTLR start "rule__Transition__Group__8__Impl"
    // InternalMyDsl.g:946:1: rule__Transition__Group__8__Impl : ( 'target' ) ;
    public final void rule__Transition__Group__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:950:1: ( ( 'target' ) )
            // InternalMyDsl.g:951:1: ( 'target' )
            {
            // InternalMyDsl.g:951:1: ( 'target' )
            // InternalMyDsl.g:952:2: 'target'
            {
             before(grammarAccess.getTransitionAccess().getTargetKeyword_8()); 
            match(input,23,FOLLOW_2); 
             after(grammarAccess.getTransitionAccess().getTargetKeyword_8()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__8__Impl"


    // $ANTLR start "rule__Transition__Group__9"
    // InternalMyDsl.g:961:1: rule__Transition__Group__9 : rule__Transition__Group__9__Impl rule__Transition__Group__10 ;
    public final void rule__Transition__Group__9() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:965:1: ( rule__Transition__Group__9__Impl rule__Transition__Group__10 )
            // InternalMyDsl.g:966:2: rule__Transition__Group__9__Impl rule__Transition__Group__10
            {
            pushFollow(FOLLOW_14);
            rule__Transition__Group__9__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Transition__Group__10();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__9"


    // $ANTLR start "rule__Transition__Group__9__Impl"
    // InternalMyDsl.g:973:1: rule__Transition__Group__9__Impl : ( ( rule__Transition__TargetStateAssignment_9 ) ) ;
    public final void rule__Transition__Group__9__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:977:1: ( ( ( rule__Transition__TargetStateAssignment_9 ) ) )
            // InternalMyDsl.g:978:1: ( ( rule__Transition__TargetStateAssignment_9 ) )
            {
            // InternalMyDsl.g:978:1: ( ( rule__Transition__TargetStateAssignment_9 ) )
            // InternalMyDsl.g:979:2: ( rule__Transition__TargetStateAssignment_9 )
            {
             before(grammarAccess.getTransitionAccess().getTargetStateAssignment_9()); 
            // InternalMyDsl.g:980:2: ( rule__Transition__TargetStateAssignment_9 )
            // InternalMyDsl.g:980:3: rule__Transition__TargetStateAssignment_9
            {
            pushFollow(FOLLOW_2);
            rule__Transition__TargetStateAssignment_9();

            state._fsp--;


            }

             after(grammarAccess.getTransitionAccess().getTargetStateAssignment_9()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__9__Impl"


    // $ANTLR start "rule__Transition__Group__10"
    // InternalMyDsl.g:988:1: rule__Transition__Group__10 : rule__Transition__Group__10__Impl ;
    public final void rule__Transition__Group__10() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:992:1: ( rule__Transition__Group__10__Impl )
            // InternalMyDsl.g:993:2: rule__Transition__Group__10__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Transition__Group__10__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__10"


    // $ANTLR start "rule__Transition__Group__10__Impl"
    // InternalMyDsl.g:999:1: rule__Transition__Group__10__Impl : ( '}' ) ;
    public final void rule__Transition__Group__10__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1003:1: ( ( '}' ) )
            // InternalMyDsl.g:1004:1: ( '}' )
            {
            // InternalMyDsl.g:1004:1: ( '}' )
            // InternalMyDsl.g:1005:2: '}'
            {
             before(grammarAccess.getTransitionAccess().getRightCurlyBracketKeyword_10()); 
            match(input,20,FOLLOW_2); 
             after(grammarAccess.getTransitionAccess().getRightCurlyBracketKeyword_10()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__Group__10__Impl"


    // $ANTLR start "rule__TuringMachine__StatesAssignment_0"
    // InternalMyDsl.g:1015:1: rule__TuringMachine__StatesAssignment_0 : ( ruleState ) ;
    public final void rule__TuringMachine__StatesAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1019:1: ( ( ruleState ) )
            // InternalMyDsl.g:1020:2: ( ruleState )
            {
            // InternalMyDsl.g:1020:2: ( ruleState )
            // InternalMyDsl.g:1021:3: ruleState
            {
             before(grammarAccess.getTuringMachineAccess().getStatesStateParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleState();

            state._fsp--;

             after(grammarAccess.getTuringMachineAccess().getStatesStateParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__StatesAssignment_0"


    // $ANTLR start "rule__TuringMachine__StatesAssignment_1_1"
    // InternalMyDsl.g:1030:1: rule__TuringMachine__StatesAssignment_1_1 : ( ruleState ) ;
    public final void rule__TuringMachine__StatesAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1034:1: ( ( ruleState ) )
            // InternalMyDsl.g:1035:2: ( ruleState )
            {
            // InternalMyDsl.g:1035:2: ( ruleState )
            // InternalMyDsl.g:1036:3: ruleState
            {
             before(grammarAccess.getTuringMachineAccess().getStatesStateParserRuleCall_1_1_0()); 
            pushFollow(FOLLOW_2);
            ruleState();

            state._fsp--;

             after(grammarAccess.getTuringMachineAccess().getStatesStateParserRuleCall_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__TuringMachine__StatesAssignment_1_1"


    // $ANTLR start "rule__State__InitialAssignment_1"
    // InternalMyDsl.g:1045:1: rule__State__InitialAssignment_1 : ( ( 'initial' ) ) ;
    public final void rule__State__InitialAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1049:1: ( ( ( 'initial' ) ) )
            // InternalMyDsl.g:1050:2: ( ( 'initial' ) )
            {
            // InternalMyDsl.g:1050:2: ( ( 'initial' ) )
            // InternalMyDsl.g:1051:3: ( 'initial' )
            {
             before(grammarAccess.getStateAccess().getInitialInitialKeyword_1_0()); 
            // InternalMyDsl.g:1052:3: ( 'initial' )
            // InternalMyDsl.g:1053:4: 'initial'
            {
             before(grammarAccess.getStateAccess().getInitialInitialKeyword_1_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getStateAccess().getInitialInitialKeyword_1_0()); 

            }

             after(grammarAccess.getStateAccess().getInitialInitialKeyword_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__InitialAssignment_1"


    // $ANTLR start "rule__State__FinalAssignment_2"
    // InternalMyDsl.g:1064:1: rule__State__FinalAssignment_2 : ( ( 'final' ) ) ;
    public final void rule__State__FinalAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1068:1: ( ( ( 'final' ) ) )
            // InternalMyDsl.g:1069:2: ( ( 'final' ) )
            {
            // InternalMyDsl.g:1069:2: ( ( 'final' ) )
            // InternalMyDsl.g:1070:3: ( 'final' )
            {
             before(grammarAccess.getStateAccess().getFinalFinalKeyword_2_0()); 
            // InternalMyDsl.g:1071:3: ( 'final' )
            // InternalMyDsl.g:1072:4: 'final'
            {
             before(grammarAccess.getStateAccess().getFinalFinalKeyword_2_0()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getStateAccess().getFinalFinalKeyword_2_0()); 

            }

             after(grammarAccess.getStateAccess().getFinalFinalKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__FinalAssignment_2"


    // $ANTLR start "rule__State__NameAssignment_4"
    // InternalMyDsl.g:1083:1: rule__State__NameAssignment_4 : ( ruleEString ) ;
    public final void rule__State__NameAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1087:1: ( ( ruleEString ) )
            // InternalMyDsl.g:1088:2: ( ruleEString )
            {
            // InternalMyDsl.g:1088:2: ( ruleEString )
            // InternalMyDsl.g:1089:3: ruleEString
            {
             before(grammarAccess.getStateAccess().getNameEStringParserRuleCall_4_0()); 
            pushFollow(FOLLOW_2);
            ruleEString();

            state._fsp--;

             after(grammarAccess.getStateAccess().getNameEStringParserRuleCall_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__NameAssignment_4"


    // $ANTLR start "rule__State__OutgoingTransitionsAssignment_5_1_0"
    // InternalMyDsl.g:1098:1: rule__State__OutgoingTransitionsAssignment_5_1_0 : ( ruleTransition ) ;
    public final void rule__State__OutgoingTransitionsAssignment_5_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1102:1: ( ( ruleTransition ) )
            // InternalMyDsl.g:1103:2: ( ruleTransition )
            {
            // InternalMyDsl.g:1103:2: ( ruleTransition )
            // InternalMyDsl.g:1104:3: ruleTransition
            {
             before(grammarAccess.getStateAccess().getOutgoingTransitionsTransitionParserRuleCall_5_1_0_0()); 
            pushFollow(FOLLOW_2);
            ruleTransition();

            state._fsp--;

             after(grammarAccess.getStateAccess().getOutgoingTransitionsTransitionParserRuleCall_5_1_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__OutgoingTransitionsAssignment_5_1_0"


    // $ANTLR start "rule__State__OutgoingTransitionsAssignment_5_1_1_1"
    // InternalMyDsl.g:1113:1: rule__State__OutgoingTransitionsAssignment_5_1_1_1 : ( ruleTransition ) ;
    public final void rule__State__OutgoingTransitionsAssignment_5_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1117:1: ( ( ruleTransition ) )
            // InternalMyDsl.g:1118:2: ( ruleTransition )
            {
            // InternalMyDsl.g:1118:2: ( ruleTransition )
            // InternalMyDsl.g:1119:3: ruleTransition
            {
             before(grammarAccess.getStateAccess().getOutgoingTransitionsTransitionParserRuleCall_5_1_1_1_0()); 
            pushFollow(FOLLOW_2);
            ruleTransition();

            state._fsp--;

             after(grammarAccess.getStateAccess().getOutgoingTransitionsTransitionParserRuleCall_5_1_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__State__OutgoingTransitionsAssignment_5_1_1_1"


    // $ANTLR start "rule__Transition__TriggerAssignment_2"
    // InternalMyDsl.g:1128:1: rule__Transition__TriggerAssignment_2 : ( ruleEString ) ;
    public final void rule__Transition__TriggerAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1132:1: ( ( ruleEString ) )
            // InternalMyDsl.g:1133:2: ( ruleEString )
            {
            // InternalMyDsl.g:1133:2: ( ruleEString )
            // InternalMyDsl.g:1134:3: ruleEString
            {
             before(grammarAccess.getTransitionAccess().getTriggerEStringParserRuleCall_2_0()); 
            pushFollow(FOLLOW_2);
            ruleEString();

            state._fsp--;

             after(grammarAccess.getTransitionAccess().getTriggerEStringParserRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__TriggerAssignment_2"


    // $ANTLR start "rule__Transition__ActionAssignment_4"
    // InternalMyDsl.g:1143:1: rule__Transition__ActionAssignment_4 : ( ruleAction ) ;
    public final void rule__Transition__ActionAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1147:1: ( ( ruleAction ) )
            // InternalMyDsl.g:1148:2: ( ruleAction )
            {
            // InternalMyDsl.g:1148:2: ( ruleAction )
            // InternalMyDsl.g:1149:3: ruleAction
            {
             before(grammarAccess.getTransitionAccess().getActionActionEnumRuleCall_4_0()); 
            pushFollow(FOLLOW_2);
            ruleAction();

            state._fsp--;

             after(grammarAccess.getTransitionAccess().getActionActionEnumRuleCall_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__ActionAssignment_4"


    // $ANTLR start "rule__Transition__NewCharAssignment_5"
    // InternalMyDsl.g:1158:1: rule__Transition__NewCharAssignment_5 : ( ruleEString ) ;
    public final void rule__Transition__NewCharAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1162:1: ( ( ruleEString ) )
            // InternalMyDsl.g:1163:2: ( ruleEString )
            {
            // InternalMyDsl.g:1163:2: ( ruleEString )
            // InternalMyDsl.g:1164:3: ruleEString
            {
             before(grammarAccess.getTransitionAccess().getNewCharEStringParserRuleCall_5_0()); 
            pushFollow(FOLLOW_2);
            ruleEString();

            state._fsp--;

             after(grammarAccess.getTransitionAccess().getNewCharEStringParserRuleCall_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__NewCharAssignment_5"


    // $ANTLR start "rule__Transition__DirectionAssignment_7"
    // InternalMyDsl.g:1173:1: rule__Transition__DirectionAssignment_7 : ( ruleDirection ) ;
    public final void rule__Transition__DirectionAssignment_7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1177:1: ( ( ruleDirection ) )
            // InternalMyDsl.g:1178:2: ( ruleDirection )
            {
            // InternalMyDsl.g:1178:2: ( ruleDirection )
            // InternalMyDsl.g:1179:3: ruleDirection
            {
             before(grammarAccess.getTransitionAccess().getDirectionDirectionEnumRuleCall_7_0()); 
            pushFollow(FOLLOW_2);
            ruleDirection();

            state._fsp--;

             after(grammarAccess.getTransitionAccess().getDirectionDirectionEnumRuleCall_7_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__DirectionAssignment_7"


    // $ANTLR start "rule__Transition__TargetStateAssignment_9"
    // InternalMyDsl.g:1188:1: rule__Transition__TargetStateAssignment_9 : ( ( ruleEString ) ) ;
    public final void rule__Transition__TargetStateAssignment_9() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:1192:1: ( ( ( ruleEString ) ) )
            // InternalMyDsl.g:1193:2: ( ( ruleEString ) )
            {
            // InternalMyDsl.g:1193:2: ( ( ruleEString ) )
            // InternalMyDsl.g:1194:3: ( ruleEString )
            {
             before(grammarAccess.getTransitionAccess().getTargetStateStateCrossReference_9_0()); 
            // InternalMyDsl.g:1195:3: ( ruleEString )
            // InternalMyDsl.g:1196:4: ruleEString
            {
             before(grammarAccess.getTransitionAccess().getTargetStateStateEStringParserRuleCall_9_0_1()); 
            pushFollow(FOLLOW_2);
            ruleEString();

            state._fsp--;

             after(grammarAccess.getTransitionAccess().getTargetStateStateEStringParserRuleCall_9_0_1()); 

            }

             after(grammarAccess.getTransitionAccess().getTargetStateStateCrossReference_9_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Transition__TargetStateAssignment_9"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000003040000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000030L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000300000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000003800L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x000000000001C000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000100000L});

}